Name:           pbench-web-server
Version:     0.47
%define gdist g2cfe130
Release:     1%{?gdist}%{!?gdist:}
Summary:        The pbench web server bits

License:        GPLv3+
URL:            http://github.com/distributed-systems-analysis/pbench
Source0:        http://pbench.perf.lab.eng.bos.redhat.com/test-repo/pbench-web-server-%{version}.tar.gz
Buildarch:      noarch

Requires:       npm

%define installdir opt/pbench-web-server
%define static %{installdir}/html/static
%define versions 0.2 0.3
%define EXTRA_FILES %{buildroot}/extra.list

%description
The pbench web server bits.

%prep
%setup
%build

%install
touch %{EXTRA_FILES}

rm -rf %{buildroot}

mkdir -p %{buildroot}/%{static}/css
mkdir -p %{buildroot}/%{static}/js

for version in %{versions};do
    install -m 755 -d %{buildroot}/%{static}/css/v$version
    install -m 755 -d %{buildroot}/%{static}/js/v$version
    install -m 755 -d %{buildroot}/%{static}/pages/v$version
done

for version in %{versions};do
    case "$version" in
        0.2)
        ;;
        0.3)
            echo /extra.list > %{EXTRA_FILES}
        ;;
        0.4)
            # v0.4 temp cruft
            install -m 755 -d %{buildroot}/%{static}/pages/v0.4/react-dashboard
            for x in core docs icons pages public test utils ;do
                install -m 755 -d %{buildroot}/%{static}/pages/v0.4/react-dashboard/$x    
            done
            cat > %{EXTRA_FILES} <<EOF
/%{static}/apps/v0.4/react-dashboard/pages/index.js
/%{static}/core/v0.4/react-dashboard/constants.js
/%{static}/core/v0.4/react-dashboard/history.js
/%{static}/core/v0.4/react-dashboard/router.js
/%{static}/core/v0.4/react-dashboard/store.js
/%{static}/docs/v0.4/react-dashboard/README.md
/%{static}/docs/v0.4/react-dashboard/routing-and-navigation.md
/%{static}/environments/v0.4/react-dashboard/pages/index.js
/%{static}/error/v0.4/react-dashboard/pages/index.js
/%{static}/error/v0.4/react-dashboard/pages/styles.css
/%{static}/home/v0.4/react-dashboard/pages/index.js
/%{static}/icons/v0.4/react-dashboard/icon-heart.png
/%{static}/icons/v0.4/react-dashboard/patternfly-orb.png
/%{static}/icons/v0.4/react-dashboard/react.png
/%{static}/json/v0.4/react-dashboard/public/apps.json
/%{static}/json/v0.4/react-dashboard/public/projects.json
/%{static}/json/v0.4/react-dashboard/public/users.json
/%{static}/pages/v0.4/react-dashboard/common.css
/%{static}/pages/v0.4/react-dashboard/variables.css
/%{static}/public/v0.4/react-dashboard/apple-touch-icon.png
/%{static}/public/v0.4/react-dashboard/brand-alt.svg
/%{static}/public/v0.4/react-dashboard/browserconfig.xml
/%{static}/public/v0.4/react-dashboard/crossdomain.xml
/%{static}/public/v0.4/react-dashboard/favicon.ico
/%{static}/public/v0.4/react-dashboard/humans.txt
/%{static}/public/v0.4/react-dashboard/index.ejs
/%{static}/public/v0.4/react-dashboard/logo-alt.svg
/%{static}/public/v0.4/react-dashboard/robots.txt
/%{static}/public/v0.4/react-dashboard/sitemap.ejs
/%{static}/public/v0.4/react-dashboard/tile-wide.png
/%{static}/public/v0.4/react-dashboard/tile.png
/%{static}/react-dashboard/v0.4/.editorconfig
/%{static}/react-dashboard/v0.4/.firebaserc
/%{static}/react-dashboard/v0.4/.travis.yml
/%{static}/react-dashboard/v0.4/LICENSE.txt
/%{static}/react-dashboard/v0.4/README.md
/%{static}/react-dashboard/v0.4/database.rules.json
/%{static}/react-dashboard/v0.4/firebase.json
/%{static}/react-dashboard/v0.4/main.js
/%{static}/react-dashboard/v0.4/package.json
/%{static}/react-dashboard/v0.4/routes.json
/%{static}/react-dashboard/v0.4/run.js
/%{static}/react-dashboard/v0.4/webpack.config.js
/%{static}/recipes/v0.4/react-dashboard/docs/how-to-integrate-material-design-lite.md
/%{static}/recipes/v0.4/react-dashboard/docs/how-to-use-sass.md
/%{static}/recipes/v0.4/react-dashboard/docs/how-to-use-with-bootstrap.md
/%{static}/stages/v0.4/react-dashboard/pages/index.js
/%{static}/test/v0.4/react-dashboard/.eslintrc
/%{static}/test/v0.4/react-dashboard/spec.js
/%{static}/users/v0.4/react-dashboard/pages/index.js
/%{static}/utils/v0.4/react-dashboard/markdown-loader.js
/%{static}/utils/v0.4/react-dashboard/routes-loader.js
EOF
        ;;
        *)
            echo "Unknown version"
            ;;
    esac

    for x in `cat MANIFEST`
    do
        v=$(dirname $(dirname $x))
        if [ "$v" = "." ] ;then continue ;fi
        c=$(dirname $x | sed "s;$v/;;")
        v=$(echo $v | sed 's;./;;')
        mkdir -p %{buildroot}/%{static}/$c/$v
        install -m 755 $x %{buildroot}/%{static}/$c/$v
    done
done

%pre

%post

%posttrans
# Create a temporary file containing the list of files

cd /%{installdir}

list="node_modules/d3/d3.js node_modules/d3/d3.min.js
      node_modules/d3-queue/build/d3-queue.js node_modules/d3-queue/build/d3-queue.min.js
      node_modules/nvd3/build/nv.d3.js node_modules/nvd3/build/nv.d3.min.js
      node_modules/nvd3/build/nv.d3.css node_modules/nvd3/build/nv.d3.min.css
      node_modules/fastdom/fastdom.js node_modules/fastdom/fastdom.min.js
      node_modules/function-bind/implementation.js
      node_modules/save-svg-as-png/saveSvgAsPng.js
      node_modules/c3/c3.js"

for version in %{versions};do
    case "$version" in
        0.2)
            mv /%{static}/js/v0.2/implementation.js /%{static}/js/v0.2/function-bind.js
        ;;
        0.3)
            # jschart deps
            npm install d3@3.5.17
            npm install d3-queue@3.0.1
            npm install nvd3@1.8.2
            npm install fastdom@1.0.3
            # what does function-bind do?
            npm install function-bind@1.1.0
            npm install save-svg-as-png@1.0.1
            npm install c3@0.4.11
            for x in $list ;do
                suffix=$(basename $x | sed 's/.*\.\([^.]*\)/\1/')
                for version in %{versions};do
                    cp $x /%{static}/$suffix/v$version
                done
            done
            mv /%{static}/$suffix/v$version/implementation.js /%{static}/$suffix/v$version/function-bind.js
        ;;
        0.4)
            # react deps
            cd /%{static}/react-dashboard/v0.4
            npm install
        ;;
        *)
            echo "Unknown version"
            ;;
    esac
done

chown -R pbench.pbench /%{installdir}

if [ -f /opt/pbench-server/bin/pbench-server-activate-web-server ] ;then
    /opt/pbench-server/bin/pbench-server-activate-web-server
fi

%preun

%postun
# if uninstalling, rather than updating, remove /opt/pbench-web-server
if [ $1 -eq 0 ] ;then
    rm -rf /%{installdir}
fi

%files -f %{EXTRA_FILES}
%defattr(755,pbench,pbench,755)
/%{static}/css/v0.2/pbench_utils.css
/%{static}/js/v0.2/pbench_utils.js
/%{static}/js/v0.2/app.js
/%{static}/css/v0.3/LICENSE.TXT
/%{static}/css/v0.3/jschart.css
/%{static}/js/v0.3/LICENSE.TXT
/%{static}/js/v0.3/jschart.js
/extra.list

%doc
